]> arthur.barton.de Git - backup-script.git/blob - bin/backup-script
Make sure that "source" does end with a slash ("/")
[backup-script.git] / bin / backup-script
1 #!/bin/bash
2 #
3 # backup-script system for cloning systems using rsync
4 # Copyright (c)2008-2015 Alexander Barton <alex@barton.de>
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12
13 NAME=$(basename "$0")
14 PIDFILE="/var/run/$NAME.pid"
15
16 DRYRUN=0
17 VERBOSE=0
18
19 export LC_ALL=C
20
21 declare -i count_all=0
22 declare -i count_started=0
23 declare -i count_ok=0
24 declare -i count_ok_vanished=0
25
26 destinations=""
27
28 # Default settings, can be overwritten in backup-script.conf:
29 conf_d="/etc/backup-script.d"
30 pre_exec=""
31 post_exec=""
32 default_source_root="/"
33 default_target=""
34 default_user="root"
35 default_ssh_args_add=""
36 default_rsync_args_add=""
37 default_exclude_args_add=""
38 default_compress=1
39 default_ping=1
40 default_local=0
41 default_generations=0
42 default_job_pre_exec=""
43 default_job_post_exec=""
44
45 Usage() {
46         echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
47         echo
48         echo "  -p, --progress    Show progress, see rsync(1)."
49         echo "  -n, --dry-run     Test run only, don't copy any data."
50         echo
51         echo "When no <system> is given, all defined systems are used."
52         echo
53         exit 1
54 }
55
56 CleanUp() {
57         if [ -n "$post_exec" ]; then
58                 echo "Executing \"$post_exec\" ..."
59                 sh -c $post_exec
60                 if [ $? -ne 0 ]; then
61                         echo "Warning: post-exec command failed!"
62                 fi
63                 echo
64         fi
65         rm -f "$PIDFILE"
66 }
67
68 GotSignal() {
69         echo
70         echo "--> Got break signal, cleaning up & aborting ..."
71         echo
72         CleanUp
73         echo -n "Aborted: "; date
74         echo
75         sleep 3
76         exit 9
77 }
78
79 ExecJob() {
80         local what="$1"
81         local cmd="$2"
82
83         echo "Running job ${what}-exec command ..."
84         [ "$local" -eq 0 ] \
85                 && cmd="$ssh_cmd ${user}@${system} $cmd"
86         echo -n "Start date (${what}-exec): "; date
87         echo "$cmd"
88         if [ "$DRYRUN" -eq 0 ]; then
89                 $SHELL -c "$cmd"; local ret=$?
90         else
91                 echo " *** Trial run, not executing ${what}-exec command!"
92                 ret=0
93         fi
94         [ $ret -eq 0 ] \
95                 && echo "The ${what}-exec command completed with status 0, OK." \
96                 || echo "The ${what}-exec command completed with ERRORS, code $ret!"
97         return $ret
98 }
99
100 GetFS() {
101         local dir="$1"
102
103         while [ -n "$dir" ]; do
104                 findmnt -fn -o FSTYPE --raw "$dir" 2>/dev/null; local r=$?
105                 if [ $r -eq 0 ]; then
106                         return 0
107                 elif [ $r -eq 127 ]; then
108                         echo "UNKNOWN"
109                         return 1
110                 fi
111                 dir=$(dirname "$dir") || return 1
112         done
113 }
114
115 CreateSubvolume() {
116         local volume="$1"
117         local fs
118         local dir
119
120         dir=$(dirname "$volume")
121         fs=$(GetFS "$dir")
122         case "$fs" in
123           "btrfs")
124                 btrfs subvolume create "$volume"  >/dev/null || return 1
125                 ;;
126           "zfs")
127                 zfs create "$(echo "$volume" | cut -c2-)" || return 1
128                 ;;
129           *)
130                 echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
131                 return 9
132         esac
133         return 0
134 }
135
136 CloneSubvolume() {
137         local source="$1"
138         local volume="$2"
139         local snapshot="$3"
140         local dir
141         local fs
142         local link_name
143
144         dir=$(dirname "source")
145         fs=$(GetFS "$source")
146         case "$fs" in
147           "btrfs")
148                 btrfs subvolume snapshot "$source" "$snapshot"  >/dev/null || return 1
149                 ;;
150           "zfs")
151                 zfs snapshot "$snapshot" || return 1
152                 link_name="$(echo "$snapshot" | cut -d@ -f2-)"
153                 ln -s \
154                         "$volume/.zfs/snapshot/$link_name" \
155                         "$(dirname "$volume")/$link_name"
156                 ;;
157           *)
158                 echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
159                 return 9
160         esac
161         return 0
162 }
163
164 RenameSubvolume() {
165         local source="$1"
166         local target="$2"
167         local fs
168
169         fs=$(GetFS "$source")
170         case "$fs" in
171           "btrfs")
172                 mv "$source" "$target" || return 1
173                 ;;
174           "zfs")
175                 zfs rename \
176                   "$(echo "$source" | cut -c2-)" \
177                   "$(echo "$target" | cut -c2-)" \
178                         || return 1
179                 ;;
180           *)
181                 echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
182                 return 9
183         esac
184         return 0
185 }
186
187 DeleteSubvolume() {
188         local volume="$1"
189         local fs
190         local id
191         local snapshot
192
193         fs=$(GetFS "$volume")
194         case "$fs" in
195           "btrfs")
196                 btrfs subvolume delete "$volume" >/dev/null || return 1
197                 ;;
198           "zfs")
199                 id="$(basename "$volume")"
200                 if [ -h "$volume" ]; then
201                         snapshot="$(dirname "$volume")/current@$id"
202                 else
203                         snapshot="$volume"
204                 fi
205                 zfs destroy -r "$(echo "$snapshot" | cut -c2-)" >/dev/null || return 1
206                 [ -h "$volume" ] && rm "$volume"
207                 ;;
208           *)
209                 echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
210                 return 9
211         esac
212         return 0
213 }
214
215 Initialize_Last_SysTarget_Snapshot() {
216         sys_target="$1"
217         unset last
218         unset snapshot
219
220         fs=$(GetFS "$sys_target")
221         case "$fs" in
222           "btrfs")
223                 # Search directory of last generation, if any
224                 last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
225                 if [ -n "$last" ]; then
226                         if [ ! -d "$last" ]; then
227                                 echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
228                                 echo
229                                 return 1
230                         fi
231                 fi
232                 sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
233                 snapshot="$sys_target"
234                 ;;
235           "zfs")
236                 # On ZFS, the last generation is always named "current"
237                 if [ -e "$sys_target/current" ]; then
238                         last="$sys_target/current"
239                         if [ "$(uname)" = "Linux" ]; then
240                                 date=$(LC_ALL=C stat "$1" | grep "^Modify: " \
241                                  | cut -d':' -f2- | cut -d. -f1)
242                         else
243                                 date=$(LC_ALL=C stat -f "%Sc" "$1")
244                         fi
245                         date=$(echo "$date" | sed -e's/^ //g' -e 's/[-:]//g' -e 's/ /-/g')
246
247                 else
248                         last=""
249                         date="$(date +%Y%m%d-%H%M%S)"
250                 fi
251                 snapshot="$(echo "$sys_target/current" | cut -c2-)@$date"
252                 sys_target="$sys_target/current"
253                 ;;
254           *)
255                 echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
256                 return 1
257         esac
258         return 0
259 }
260
261 while [ $# -gt 0 ]; do
262         case "$1" in
263           "-n"|"--dry-run")
264                 DRYRUN=1; shift
265                 ;;
266           "-p"|"--progress")
267                 VERBOSE=1; shift
268                 ;;
269           "-"*)
270                 Usage
271                 ;;
272           *)
273                 break
274         esac
275 done
276
277 trap GotSignal SIGINT
278
279 echo -n "Started: "; date
280
281 for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
282         if [ -r "$conf" ]; then
283                 echo "Reading configuration: \"$conf\" ..."
284                 source "$conf"
285         fi
286 done
287 echo
288
289 if [ $# -ge 1 ]; then
290         for s in "$@"; do
291                 if [ ! -r "${conf_d}/$s" ]; then
292                         echo "$NAME: Can' read \"${conf_d}/$s\"!"
293                         exit 1
294                 fi
295                 sys="$sys ${conf_d}/$s"
296         done
297 else
298         sys="${conf_d}/"*
299 fi
300
301 # check and create PID file
302 if [ -e "$PIDFILE" ]; then
303         echo "Lockfile \"$PIDFILE\" already exists."
304         echo "Is an other instance still running?"
305         echo
306         echo -n "Aborted: "; date
307         echo
308         exit 3
309 fi
310 touch "$PIDFILE" 2>/dev/null
311 if [ $? -ne 0 ]; then
312         echo "Warning: can't create PID file \"$PIDFILE\"!"
313         echo
314 else
315         echo "$$" >>"$PIDFILE"
316 fi
317
318 if [ -n "$pre_exec" ]; then
319         echo "Executing \"$pre_exec\" ..."
320         sh -c $pre_exec
321         if [ $? -ne 0 ]; then
322                 echo "Error: pre-exec command failed!"; echo
323                 CleanUp
324                 echo "Aborting backup."; echo
325                 exit 2
326         fi
327         sleep 2
328         echo
329 fi
330
331 for f in $sys; do
332         [ -r "$f" -a -f "$f" ] || continue
333
334         fname=$(basename "$f")
335         case "$fname" in
336                 "backup-script.conf"|*.sh)
337                         continue
338                         ;;
339         esac
340
341         # Set global defaults
342         system="$fname"
343         user="$default_user"
344         source_root="$default_source_root"
345         target="$default_target"
346         ssh_args_add="$default_ssh_args_add"
347         rsync_args_add="$default_rsync_args_add"
348         exclude_args_add="$default_exclude_args_add"
349         compress="$default_compress"
350         ping="$default_ping"
351         local="$default_local"
352         generations="$default_generations"
353         job_pre_exec="$default_job_pre_exec"
354         job_post_exec="$default_job_post_exec"
355
356         # Compatibility with backup-pull(1) script: Save global values ...
357         pre_exec_saved="$pre_exec"
358         post_exec_saved="$post_exec"
359
360         # Compatibility with backup-pull(1) script: Set defaults
361         unset host
362         unset source
363         unset pre_exec
364         unset post_exec
365
366         # Read in system configuration file
367         source "$f"
368
369         # Compatibility with backup-pull(1) script: Fix up configuration
370         [ "$system" = "$fname" -a -n "$host" ] \
371                 && system="$host"
372         [ "$source_root" = "$default_source_root" -a -n "$source" ] \
373                 && source_root="$source"
374         [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
375                 && job_pre_exec="$pre_exec"
376         [ -z "$job_post_exec" -a -n "$post_exec" ] \
377                 && job_post_exec="$post_exec"
378
379         # Compatibility with backup-pull(1) script: Restore global values ...
380         pre_exec="$pre_exec_saved"
381         post_exec="$post_exec_saved"
382
383         # Validate configuration
384         [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
385
386         # Make sure "source" ends with a slash ("/")
387         case "$source" in
388           "*/")
389                 ;;
390           "*")
391                 source="$source/"
392         esac
393
394         [ "$system" = "$fname" ] \
395                 && systxt="\"$system\"" \
396                 || systxt="\"$fname\" [\"$system\"]"
397         [ "$local" -eq 0 ] \
398                 && echo "Working on $systxt ..." \
399                 || echo "Working on $systxt (local system) ..."
400
401         count_all=$count_all+1
402
403         # Check target directory
404         if [ -z "$target" ]; then
405                 echo "No target directory specified for \"$system\"!? Skipped!"
406                 echo; continue
407         fi
408         if [ ! -d "$target" ]; then
409                 echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
410                 echo; continue
411         fi
412
413         sys_target="$target/$fname"
414         sys_root="$sys_target"
415         if [ "$DRYRUN" -eq 0 -a ! -e "$sys_target" ]; then
416                 if [ $generations -gt 0 ]; then
417                         CreateSubvolume "$sys_target"
418                 else
419                         mkdir -p "$sys_target"
420                 fi
421                 if [ $? -ne 0 ]; then
422                         echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
423                         echo; continue
424                 fi
425         fi
426
427         if [ "$local" -eq 0 -a "$ping" -ne 0 ]; then
428                 # Check if system is alive
429                 ping -c 1 "$system" >/dev/null 2>&1
430                 if [ $? -ne 0 ]; then
431                         echo "Host \"$system\" seems not to be alive!? Skipped."
432                         echo; continue
433                 fi
434                 echo "OK, host \"$system\" seems to be alive."
435         fi
436
437         if [ $generations -gt 0 ]; then
438                 # Make sure no old backup is stored in system directory
439                 if [ -e "$sys_target/.stamp" ]; then
440                         # There seems to be a genearation-less backup in the
441                         # target directory!
442                         echo "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
443                         echo; continue
444                 fi
445
446                 Initialize_Last_SysTarget_Snapshot "$sys_target" || continue
447
448                 if [ -n "$last" -a ! -e "$last/.stamp" ]; then
449                         # Old backup directory without "stamp file", continue
450                         echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
451                         RenameSubvolume "$last" "$sys_target"
452                         if [ $? -ne 0 ]; then
453                                 echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
454                                 echo; continue
455                         fi
456                 elif [ -n "$last" ]; then
457                         # Old backup directory found, create new snapshot
458                         echo "Found last snapshot in \"$last\"."
459                         if [ "$DRYRUN" -eq 0 ]; then
460                                 CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
461                                 if [ $r -ne 0 ]; then
462                                         echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
463                                         echo; continue
464                                 fi
465                                 echo "Created new snapshot in \"$snapshot\"."
466                         else
467                                 echo " *** Trial run, not creating new snapshot in \"$snapshot\"!"
468                         fi
469                 else
470                         # No old backup found, create new subvolume
471                         if [ "$DRYRUN" -eq 0 ]; then
472                                 CreateSubvolume "$sys_target"; r=$?
473                                 if [ $r -ne 0 ]; then
474                                         echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
475                                         echo; continue
476                                 fi
477                                 echo "Created new subvolume in \"$sys_target\"."
478                         else
479                                 echo " *** Trial run, not creating new subvolume \"$sys_target\"!"
480                         fi
481                 fi
482         fi
483
484         ssh_cmd="ssh"
485         [ -n "$ssh_args_add" ] && ssh_cmd="$ssh_cmd $ssh_args_add"
486
487         # execute job "pre-exec" command, if any
488         if [ -n "$job_pre_exec" ]; then
489                 ExecJob pre "$job_pre_exec" ; ret=$?
490                 if [ $ret -ne 0 ]; then
491                         [ $ret -ne 99 ] && count_started=$count_started+1
492                         echo "Pre-exec command failed, \"$system\" skipped!"
493                         echo; continue
494                 fi
495         fi
496
497         # prepare (remote) command ...
498         cmd="rsync --archive"
499         [ "$compress" -ne 0 ] && cmd="$cmd --compress"
500         [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
501         cmd="$cmd --delete --delete-excluded --sparse"
502         [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
503         if [ "$source_root" = "$default_source_root" ]; then
504                 cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
505                 cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
506                 cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
507                 cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
508         fi
509         [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
510         [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
511
512         [ "$local" -eq 0 ] \
513                 && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
514                 || cmd="$cmd $source_root $sys_target/"
515
516         echo "Backing up to \"$sys_target\" ..."
517         echo -n "Start date: "; date
518         echo "$cmd"
519         count_started=$count_started+1
520         ok=0
521
522         if [ "$DRYRUN" -eq 0 ]; then
523                 rm -f "$sys_target/.stamp"
524                 $SHELL -c "$cmd"; ret=$?
525                 echo "code=$ret" >"$sys_target/.stamp"
526         else
527                 echo " *** Trial run, not executing synchronization command!"
528                 ret=0
529         fi
530
531         if [ $ret -eq 20 ]; then
532                 echo "Backup of \"$system\" interrupted. Aborting ..."
533                 CleanUp
534                 exit 1
535         fi
536
537         echo -n "End date: "; date
538         if [ $ret -eq 0 -o $ret -eq 24 ]; then
539                 [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
540
541                 echo "System \"$system\" completed with status $ret, OK."
542                 [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
543                 ok=1
544         else
545                 echo "System \"$system\" completed with ERRORS, code $ret!"
546         fi
547
548         # execute job "post-exec" command, if any
549         if [ -n "$job_post_exec" ]; then
550                 ExecJob post "$job_post_exec"
551         fi
552
553         if [ $generations -gt 0 ]; then
554                 # Update "latest" symlink
555                 if [ "$DRYRUN" -eq 0 ]; then
556                         rm -f "$sys_root/latest"
557                         ln -s "$sys_target" "$sys_root/latest"
558                 fi
559                 # Clean up old generations
560                 declare -i gen_count=$generations+2
561                 to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
562                 if [ -n "$to_delete" -a $ok -eq 1 ]; then
563                         [ "$DRYRUN" -eq 0 ] \
564                                 && echo "Deleting old backup generations (keep $generations) ..." \
565                                 || echo " *** Trial run, not deleting old generations:"
566                         for delete in $to_delete; do
567                                 dir="$sys_root/$delete"
568                                 if [ ! -e "$dir/.stamp" ]; then
569                                         echo "Not deleting \"$dir\", not a backup directory!?"
570                                         continue
571                                 fi
572                                 last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
573                                  | cut -d':' -f2- | cut -d. -f1)
574                                 echo "Removing backup from" $last "..."
575                                 if [ "$DRYRUN" -eq 0 ]; then
576                                         DeleteSubvolume "$dir"
577                                         [ $? -eq 0 ] || \
578                                           echo "Failed to delete \"$dir\"!"
579                                 fi
580                         done
581                         echo -n "Clean up finished: "; date
582                 elif [ -n "$to_delete" ]; then
583                         echo "There have been errors, not cleaning up old generations!"
584                 else
585                         echo "Nothing to clean up."
586                 fi
587         fi
588
589         destinations="$destinations $target"
590         echo
591 done
592
593 sync
594
595 paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
596 if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
597         df -h $paths
598         echo
599 fi
600
601 CleanUp
602
603 echo -n "Done: "; date
604 echo
605 [ $count_all -eq 1 ] && s="" || s="s"
606 echo " - $count_all job$s defined,"
607 [ $count_started -eq 1 ] && s="" || s="s"
608 echo " - $count_started job$s started,"
609 echo " - $count_ok done without errors."
610 echo
611
612 if [ $count_started -ne $count_ok ]; then
613         echo "----->  THERE HAVE BEEN ERRORS!  <-----"
614         echo
615 fi
616
617 # -eof-